"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.getTemplateUrlMapping = exports.createApp = void 0;
const child_process_1 = __importDefault(require("child_process"));
const path_1 = __importDefault(require("path"));
function createApp(templateUrl, folderName) {
    return __awaiter(this, void 0, void 0, function* () {
        try {
            const { exitCode } = yield executeCloneOfRepo(templateUrl, folderName);
            if (exitCode == 0) {
                console.log("App created successfully");
            }
            else {
                throw new Error("There was an issue creating app.");
            }
        }
        catch (error) {
            console.log("Error: ", error.message);
        }
        finally {
            process.exit(0);
        }
    });
}
exports.createApp = createApp;
function executeCloneOfRepo(sourceUrl, folderName) {
    return new Promise((resolve) => {
        const child = child_process_1.default.spawn("sh", [path_1.default.join(__dirname, "../scripts/clone.sh")], {
            shell: true,
            env: {
                SOURCE_URL: sourceUrl,
                FOLDER_NAME: folderName,
            },
        });
        let exitCode = 0;
        child.stdout.setEncoding("utf8");
        child.on("error", () => {
            exitCode = 1;
        });
        child.stderr.setEncoding("utf8");
        child.stderr.on("data", (data) => {
            console.log(data);
        });
        child.on("close", () => {
            resolve({ exitCode });
        });
    });
}
function getTemplateUrlMapping(alias) {
    if (alias === "Portfolio") {
        return "https://github.com/spheronFdn/portfolio-template";
    }
    else if (alias === "NFT Drop") {
        return "https://github.com/spheronFdn/react-boilerplate";
    }
    else if (alias === "React") {
        return "https://github.com/spheronFdn/react-boilerplate";
    }
    else if (alias === "Next.js") {
        return "https://github.com/spheronFdn/react-boilerplate";
    }
    throw new Error("Mapping for template not found");
}
exports.getTemplateUrlMapping = getTemplateUrlMapping;
