"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.publish = void 0;
const configuration_1 = __importDefault(require("../configuration"));
const utils_1 = require("../utils");
const upload_1 = require("./upload");
function publish() {
    return __awaiter(this, void 0, void 0, function* () {
        try {
            const localJsonPath = "./spheron.json";
            const projectConfig = yield (0, utils_1.fileExists)(localJsonPath);
            if (!projectConfig) {
                throw new Error("spheron.json file does not exist. Please create it with spheron init command");
            }
            const spheronConfig = yield (0, utils_1.fileExists)(configuration_1.default.configFilePath);
            if (!spheronConfig) {
                throw new Error(`global spheron configuration does not exist at ${configuration_1.default.configFilePath}. Please execute spheron create-configuration command`);
            }
            const localConfiguration = yield (0, utils_1.readFromJsonFile)("configuration", localJsonPath);
            const organizationId = yield (0, utils_1.readFromJsonFile)("organization", configuration_1.default.configFilePath);
            if (!organizationId) {
                throw new Error("Please specify organization that you would wish to use while uploading");
            }
            console.log("Publishing in progress");
            yield (0, upload_1.upload)(localConfiguration.rootPath, localConfiguration.protocol, organizationId, localConfiguration.name);
        }
        catch (error) {
            console.log(error.message);
            throw error;
        }
    });
}
exports.publish = publish;
